<?php

namespace Payshop\Core\Gateway\Initialize\Request;

use Payshop\Core\Action\CreateInstrument;
use Magento\Payment\Gateway\Data\PaymentDataObjectInterface;

class InstrumentRequest implements \Magento\Payment\Gateway\Request\BuilderInterface
{
    /**
     * @var CreateInstrument
     */
    private CreateInstrument $createInstrument;

    /**
     * InstrumentRequest constructor.
     * 
     * @param CreateInstrument $createInstrument
     */
    public function __construct(
        CreateInstrument $createInstrument
    ) {
        $this->createInstrument = $createInstrument;
    }

    /**
     * build instrument request
     * 
     * @param array $buildSubject
     * @return array
     */
    public function build(array $buildSubject)
    {
        if (!isset($buildSubject['payment'])
            || !$buildSubject['payment'] instanceof PaymentDataObjectInterface
        ) {
            throw new \InvalidArgumentException('Payment data object should be provided');
        }

        $paymentDataObject = $buildSubject['payment'];

        $payment = $paymentDataObject->getPayment();

        return [
            'instrument' => $this->createInstrument->getData($payment)
        ];
    }
}
