<?php

namespace Payshop\Core\Observer;

use Magento\Framework\Event\Observer;
use Magento\Payment\Observer\AbstractDataAssignObserver;

class MBWayDataAssignObserver extends AbstractDataAssignObserver
{
    /**
     * @inheritDoc
     */
    public function execute(Observer $observer)
    {
        $data = $this->readDataArgument($observer);

        /** @var \Magento\Quote\Model\Quote\Payment $paymentInfo */
        $paymentInfo = $this->readPaymentModelArgument($observer);

        $additionalData = $data->getDataByKey('additional_data');

        if (isset($additionalData['phone'])) {
            $paymentInfo->setAdditionalInformation(
                'phone',
                $additionalData['phone']
            );
        }
    }
}
