require(
    [
        'jquery'
    ],
    function ($) {
        (function () {
            function displayById(elementId, display = 'block') {
                let element = document.getElementById(elementId);
                element.style.display = display;
            }

            function handlePopup(interval, popupId) {
                clearInterval(interval);
                displayById('waiting-mbway', 'none')
                displayById(popupId)

                document.getElementById(popupId + '-button').addEventListener('click', function () {
                    document.getElementById(popupId).style.display = 'none';
                });
            }

            function checkMBWayPayment() {
                displayById('waiting-mbway', 'block');

                let url = $('#payshop-site-url').val();
                let orderId = $('#payshop-order').val();

                let interval = setInterval(function () {
                    $.ajax({
                        url: url + 'payshop/mbway/check',
                        data: {
                            orderId
                        },
                        success: function (data) {
                            if (data.status == 'paid') {
                                handlePopup(interval, 'accepted-mbway');
                            }

                            if (data.status == 'declined') {
                                handlePopup(interval, 'declined-mbway');
                            }
                        },
                        error: function (error) {
                            alert('An error occurred, please try again later');
                        }
                    });
                }, 3000);
            }

            setTimeout(function () {
                checkMBWayPayment();
            }, 3000);
        })();
    }
)